program test

  use kmath_lib_mod
  use kmath_plugin_rnd_kmath_random_mod

  implicit none

#include <finclude/petscsys.h>
#include <finclude/petscvec.h>

  Vec                      :: X
  integer                  :: ierr, nvec
  type(s_context)          :: h


  nvec = 20

  call PetscInitialize(PETSC_NULL_CHARACTER, ierr)


  ! create vector
  call VecCreate  (PETSC_COMM_WORLD, X, ierr)
  call VecSetType (X, VECMPI, ierr)
  call VecSetSizes(X, PETSC_DECIDE, nvec, ierr)

  ! solve by KMATH API (with KMATH_Random)
  call KMATH_Create(h, PETSC_COMM_WORLD, ierr)

  call KMATH_Set_Plugin(h, KMATH_Plugin_Setup_Rnd_KMATH_Random, ierr)
  call KMATH_Set_Parameter(h, 'X', X,  ierr)
  call KMATH_Solve(h, ierr)

  call KMATH_Destroy(h, ierr)

  ! result check
  call VecView(X, PETSC_VIEWER_STDOUT_WORLD, ierr)

  call VecDestroy(X,ierr)

  call PetscFinalize(ierr)

  stop

end program test
